From 14b2884c871ecff78e41a8d68f0bc1562aead7b7 Mon Sep 17 00:00:00 2001
From: Matthias Kuhn <matthias.kuhn@gmx.ch>
Date: Wed, 29 Aug 2012 18:24:14 +0200
Subject: [PATCH] Proper handling of NULL value for combobox A NULL value was
 not selected in ordered mode in a combobox. Additionally,
 NULL value is now always the first item.

---
 src/gui/qgsattributeeditor.cpp | 5 ++---
 1 file changed, 2 insertions(+), 3 deletions(-)

diff --git a/src/gui/qgsattributeeditor.cpp b/src/gui/qgsattributeeditor.cpp
index 00b16d3..33098cc 100644
--- a/src/gui/qgsattributeeditor.cpp
+++ b/src/gui/qgsattributeeditor.cpp
@@ -209,9 +209,6 @@ QWidget *QgsAttributeEditor::createAttributeEditor( QWidget *parent, QWidget *ed
         if ( !data.mFilterAttributeColumn.isNull() )
           fi = layer->fieldNameIndex( data.mFilterAttributeColumn );
 
-        if ( data.mAllowNull )
-          map.insert( nullValue, tr( "(no selection)" ) );
-
         if ( ki >= 0 && vi >= 0 )
         {
           QgsAttributeList attributes;
@@ -236,6 +233,8 @@ QWidget *QgsAttributeEditor::createAttributeEditor( QWidget *parent, QWidget *ed
         QComboBox *cb = comboBox( editor, parent );
         if ( cb )
         {
+          if ( data.mAllowNull )
+            cb->addItem( tr( "(no selection)" ), nullValue );
           for ( QMap< QString, QString >::const_iterator it = map.begin(); it != map.end(); it++ )
           {
             if ( data.mOrderByValue )
-- 
1.7.11.msysgit.1

